#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include "isdio.h"


#ifdef HAVE_W3C_LIBWWW_WWWLIB_H
#include "w3c-libwww/WWWLib.h"
#ifdef LIBWWW_SHARED
#include "HTextImp.h"
#endif
#endif   

#ifdef _Windows
#include <io.h>
#endif
#include "isdlp.h"

/* 
#define LPSERVICE "lpservice"
*/
#define LPSERVICE "eat"

void 
main(int argc, char **argv)
{
	SOCKET sock;
	int i, fd, bytes;
	isdHeader header;
	char *msgBuffer;
	char input[4096];

	if (argc > 2) {
		if ((sock = isdLogin(NULL, LPSERVICE, 2)) != -1) {
			memset((void *) &header, '\0', sizeof header);
			header.reply = 1;
			header.more = 1;
			header.command = ISDLPQUEUENAME;
			isdSend(sock, argv[1], -1, &header);

			header.command = 0;
			for (i = 2; i < argc; i++) {

				fd = open(argv[i], O_RDONLY | O_BINARY);
				if (fd >= 0) {
					for (header.sequence = 1; bytes = read(fd, input, 2048); header.sequence++)
						isdSend(sock, input, bytes, &header);

					header.more = 0;
					isdSend(sock, "", 0, &header);

					do {
						if (msgBuffer = isdRecv(sock, &header))
							fwrite(msgBuffer, header.len, 1, stdout);
						else
							break;
					} while (header.more);
				}
			}
			isdLogout(sock);
		}
		else
			perror("isdLogin()");
	}
	else
		fprintf(stderr, "usage: %s queuename filename\n", argv[0]);
	exit(0);
}
